-- Name: RAT-004 - Fixed Departure and Destination
-- Author: funkyfranky
-- Date Created: 24 Sep 2017
--
-- # Situation:
--
-- Spawn several aircraft of the same type at Guadauta or Batumi and make them fly to Gelendzhik or Beslan.
-- 
-- # Test cases:
-- 
-- 1. Observe five Yak-40 aircraft being spawned at Gudauta or Batumi. Their destination will be either Gelendzhik or Beslan.
--    After the aircraft arrive at their destination they get despawned and then respawned again at one of the defined departure airports.
--    Then they will travel to one of the defined destinations again.

-- Create RAT object. The only required parameter is the name of the template group in the mission editor.
local An26=RAT:New("RAT_An26-2")

-- Set destination airports. If multiple destinations are specified, they have to be given as a table, i.e. in curly brackets {}.
An26:SetDeparture({"Ercan", "Larnaca", "Gazipasa", "Adana Sakirpasa", "Hatay", "Gaziantep", "Damascus", "Beirut-Rafic Hariri",})

-- Set destination airports. One of these is chosen randomly as destination.
An26:SetDestination({"Ercan", "Larnaca", "Gazipasa", "Adana Sakirpasa", "Hatay", "Gaziantep", "Damascus", "Beirut-Rafic Hariri",})

-- Spawn five aircraft.
An26:Spawn(1)